<?php
/**
 * MicroEngine CMS
 * https://microengine.jp
 *
 * (c) 2018 MicroEngine Inc.
 */

namespace MicroEngine\Admin\Controllers;

use MicroEngine\Admin\Services\Log;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use MicroEngine\Core\Controllers\Controller;

class LogController extends Controller
{
    /**
     * @param  ServerRequestInterface $request
     * @param  ResponseInterface $response
     * @param  array $args
     * @return ResponseInterface
     */
    public function viewer(ServerRequestInterface $request, ResponseInterface $response, array $args): ResponseInterface
    {
        $this->c->userManager->required('log');

        /* @var Log $log */
        $log = $this->c->log;
        $filename = $args['filename'] ?? current_log_filename();
        $content = $log->content($filename);
        $files = $log->files();
        if (!in_array($filename, $files)) {
            array_unshift($files, $filename);
        }

        return $this->view->render(
            $response,
            'admin/views/log/viewer.twig',
            compact('filename', 'content', 'files')
        );
    }
}
