<?php
/**
 * MicroEngine CMS
 * https://microengine.jp
 *
 * (c) 2018 MicroEngine Inc.
 */

namespace MicroEngine\Admin\Middleware;

use MicroEngine\Admin\Auth\Auth;
use Psr\Http\Message\ResponseInterface;
use MicroEngine\Core\Middleware\Middleware;
use Psr\Http\Message\ServerRequestInterface;

class AuthMiddleware extends Middleware
{
    /**
     * @param  ServerRequestInterface $request
     * @param  ResponseInterface $response
     * @param  callable $next
     * @return ResponseInterface
     */
    public function __invoke(ServerRequestInterface $request, ResponseInterface $response, callable $next): ResponseInterface
    {
        /* @var Auth $auth */
        $auth = $this->c->auth;
        if (!$auth->authenticated()) {
            if ($request->isGet()) {
                $auth->setRequestedPath($request->getUri()->getPath());
            }
            return $response->withRedirect($this->c->router->pathFor(Auth::LOGIN_ROUTE));
        }
        return $next($request, $response);
    }
}
