<?php
/**
 * MicroEngine CMS
 * https://microengine.jp
 *
 * (c) 2018 MicroEngine Inc.
 */

namespace MicroEngine\Admin\Views;

use Twig\TwigFunction;
use Twig\Extension\AbstractExtension;
use Interop\Container\ContainerInterface;

class AdminExtension extends AbstractExtension
{
    /**
     * @var ContainerInterface
     */
    protected $c;
    /**
     * @var MicroEngine\Admin\Auth\Auth
     */
    protected $auth;

    /**
     * @param ContainerInterface $c
     */
    public function __construct(ContainerInterface $c)
    {
        $this->c = $c;
        $this->auth = $c->auth;
    }

    /**
     * Twig function 定義
     *
     * @return array
     */
    public function getFunctions(): array
    {
        return [
            new TwigFunction('auth', function () {
                if ($this->auth->authenticated()) {
                    return $this->auth->getUser();
                } else {
                    return false;
                }
            }),
            new TwigFunction('portlet', function ($name) {
                $portlet = $this->c->portlet;

                return $portlet->portlet($name);
            }, ['is_safe' => ['html']]),
            new TwigFunction('current_path', function () {
                return $this->c->request->getUri()->getPath();
            }),
        ];
    }
}
