<?php
/**
 * MicroEngine CMS
 * https://microengine.jp
 *
 * (c) 2018 MicroEngine Inc.
 */

namespace MicroEngine\Cms\Forms;

use MicroEngine\Core\Forms\Form;

class CategoryForm extends Form
{
    /**
     * @var array
     */
    protected $inputs = [
        'parent_id' => [
            'label' => '親カテゴリ',
            'value' => '',
            'rule' => 'required|numeric',
        ],
        'name' => [
            'label' => '名前',
            'value' => '',
            'rule' => 'required|max_chars:128',
        ],
        'dir' => [
            'label' => 'ディレクトリ',
            'value' => '',
            'rule' => 'required|dir_path|max:191',
        ],
        'display_order' => [
            'label' => '表示順',
            'value' => '10',
            'rule' => 'required|numeric|between_num:-32768,32767',
        ],
    ];

    /**
     * 入力値をセット
     *
     * @param array $data
     */
    public function setInputValue($data)
    {
        parent::setInputValue($data);

        $value = $this->inputs['dir']['value'];
        if (strlen($value)) {
            // パスの末尾のスラッシュを補完する
            $this->inputs['dir']['value'] = end_slash($value);
        }
    }
}
