<?php
/**
 * MicroEngine CMS
 * https://microengine.jp
 *
 * (c) 2018 MicroEngine Inc.
 */

namespace MicroEngine\Cms\Models;

use MicroEngine\Admin\Models\User;
use Illuminate\Database\Eloquent\Model;

class CalendarRevision extends Model
{
    /**
     * @var array
     */
    protected $fillable = ['calendar_id', 'revision_type', 'date', 'type', 'fields', 'visibility', 'published_at', 'closed_at', 'update_user_id'];
    /**
     * @var array
     */
    protected $casts = ['fields' => 'array'];

    /**
     * 更新ユーザー
     *
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     */
    public function updateUser()
    {
        return $this->belongsTo(User::class, 'update_user_id');
    }
}
