<?php
/**
 * MicroEngine CMS
 * https://microengine.jp
 *
 * (c) 2018 MicroEngine Inc.
 */

namespace MicroEngine\Core\Validation;

use Rakit\Validation\Rule;

class BetweenChars extends Rule
{
    /**
     * @var string
     */
    protected $message = ':attributeは:min文字以上:max文字以下でなければなりません。';
    /**
     * @var array
     */
    protected $fillableParams = ['min', 'max'];

    /**
     * @param mixed $value
     * @return bool
     */
    public function check($value): bool
    {
        $this->requireParameters($this->fillableParams);

        $min = (int)$this->parameter('min');
        $max = (int)$this->parameter('max');
        $length = mb_strlen($value);

        if ($length !== false && ($length >= $min && $length <= $max)) {
            return true;
        } else {
            return false;
        }
    }
}


