<?php
/**
 * MicroEngine CMS
 * https://microengine.jp
 *
 * (c) 2018 MicroEngine Inc.
 */

namespace MicroEngine\Core\Validation;

use Rakit\Validation\Rule;

class PhpSyntaxRule extends Rule
{
    /**
     * @var string
     */
    protected $message = ":attribute のPHP構文解析時にエラーが発生しました。\n行番号： :line\nメッセージ： :message";

    /**
     * @param $value
     * @return bool
     */
    public function check($value): bool
    {
        $result = true;

        $temp = tmpfile();
        fwrite($temp, $value);
        $metaData = stream_get_meta_data($temp);
        $fullPath = $metaData['uri'];

        try {
            // PHPコードを読み込んでエラーがでるか確認する
            require $fullPath;
        } catch (\Throwable $e) {
            $this->setParameter('line', $e->getLine());
            $this->setParameter('message', $e->getMessage());

            $result = false;
        }
        return $result;
    }
}
