<?php
/**
 * MicroEngine CMS
 * https://microengine.jp
 *
 * (c) 2018 MicroEngine Inc.
 */

namespace MicroEngine\Core\Views;

use Slim\Views\Twig;
use Psr\Http\Message\ResponseInterface;

class View extends Twig
{
    /**
     * テンプレートをレンダリングする
     *
     * @param  ResponseInterface $response
     * @param  string $template テンプレートディレクトリからの相対パス
     * @param  array $data テンプレート変数の連想配列
     * @return ResponseInterface
     */
    public function render(ResponseInterface $response, $template, $data = [])
    {
        // HTMLを取得
        $html = $this->fetch($template, $data);
        // 製品名を取得
        $name = config('settings.name');
        if ($name !== null) {
            // meta要素を追加
            $html = str_ireplace('</head>', '<meta name="generator" content="' . $name . '">' . "\n</head>", $html);
        }
        $response->getBody()->write($html);

        return $response;
    }
}
