<?php
/**
 * MicroEngine CMS
 * https://microengine.jp
 *
 * (c) 2018 MicroEngine Inc.
 */

namespace MicroEngine\Install\Middleware;

use Psr\Http\Message\ResponseInterface;
use MicroEngine\Core\Middleware\Middleware;
use MicroEngine\Core\Exception\MeException;
use Psr\Http\Message\ServerRequestInterface;
use MicroEngine\Install\Services\InstallService;

class InstalledMiddleware extends Middleware
{
    /**
     * @param  ServerRequestInterface $request
     * @param  ResponseInterface $response
     * @param  callable $next
     * @return ResponseInterface
     * @throws \Exception
     */
    public function __invoke(ServerRequestInterface $request, ResponseInterface $response, callable $next): ResponseInterface
    {
        /** @var InstallService $installService */
        $installService = $this->c->installService;

        if ($installService->installed()) {
            throw new MeException('インストール済みのためインストーラーは実行できません。');
        }
        return $next($request, $response);
    }
}
