/**
 * MicroEngine CMS
 * https://microengine.jp
 *
 * (c) 2018 MicroEngine Inc.
 */

(function ($, window) {
  'use strict';

  if (typeof window.mecms === 'undefined') {
    window.mecms = {};
  }

  /**
   * backup
   */
  mecms.backup = {
    init: function () {
      var self = this;

      $('#bulkCheckbox').on('change', function (e) {
        self.bulkCheckbox(e);
      });
      $('#buldDelete').on('click', function (e) {
        self.bulkDelete(e);
      });
    },
    bulkCheckbox: function (e) {
      $('#backupListForm input[type="checkbox"]').prop('checked', $(e.target).is(':checked'));
    },
    bulkDelete: function (e) {
      var self = this, $modal;

      if ($('#backupListForm input[name="paths[]"]:checked').length < 1) {
        e.preventDefault();
        alert('ファイルが選択されていません。');
        return false;
      }

      $modal = $('#destroyModal');
      $modal.modal('show');

      var $inputs = $('#backupListForm input[name="paths[]"]');
      var $form = $('#destroyForm');
      $form.find('input[name="paths[]"]').remove();
      $form.append($inputs.clone().hide());

      return true;
    }
  };

})(jQuery, window);
